unit Export;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  wcrypt2, StdCtrls, Buttons;

type
  TExportForm = class(TForm)
    Label1: TLabel;
    ContainerEdit: TEdit;
    SaveDialog1: TSaveDialog;
    ExportGroupBox: TGroupBox;
    KEKCheckBox: TCheckBox;
    SKCheckBox: TCheckBox;
    OKBtn: TBitBtn;
    CloseBtn: TBitBtn;
    procedure CloseBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ExportForm: TExportForm;

implementation

{$R *.DFM}

procedure TExportForm.CloseBtnClick(Sender: TObject);
begin
Close;
end;

procedure TExportForm.OKBtnClick(Sender: TObject);
var cont: PChar;
    err: string;
    hProv: HCRYPTPROV;
    key: HCRYPTKEY;
    pbuf: PBYTE;
    buflen: DWORD;
begin
if not (KEKCheckBox.Checked or SKCheckBox.Checked) then exit;
if length(ContainerEdit.Text) = 0
then
    begin
    cont := nil;
    err := ' ';
    end
else
    begin
    err := ContainerEdit.Text;
    cont := StrAlloc(length(err) + 1);
    StrPCopy(cont, err);
    end;
if not CryptAcquireContext(@hProv, cont, nil, PROV_RSA_FULL, 0)
then
    begin
    case int64(GetLastError) of
    ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
    ERROR_NOT_ENOUGH_MEMORY: err := 'ERROR_NOT_ENOUGH_MEMORY';
    NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
    NTE_BAD_KEYSET: err := 'NTE_BAD_KEYSET';
    NTE_BAD_KEYSET_PARAM: err := 'NTE_BAD_KEYSET_PARAM';
    NTE_BAD_PROV_TYPE: err := 'NTE_BAD_PROV_TYPE';
    NTE_BAD_SIGNATURE: err := 'NTE_BAD_SIGNATURE';
    NTE_EXISTS: err := 'NTE_EXISTS';
    NTE_KEYSET_ENTRY_BAD: err := 'NTE_KEYSET_ENTRY_BAD';
    NTE_KEYSET_NOT_DEF: err := 'NTE_KEYSET_NOT_DEF';
    NTE_NO_MEMORY: err := 'NTE_NO_MEMORY';
    NTE_PROV_DLL_NOT_FOUND: err := 'NTE_PROV_DLL_NOT_FOUND';
    NTE_PROV_TYPE_ENTRY_BAD: err := 'NTE_PROV_TYPE_ENTRY_BAD';
    NTE_PROV_TYPE_NO_MATCH: err := 'NTE_PROV_TYPE_NO_MATCH';
    NTE_PROV_TYPE_NOT_DEF: err := 'NTE_PROV_TYPE_NOT_DEF';
    NTE_PROVIDER_DLL_FAIL: err := 'NTE_PROVIDER_DLL_FAIL';
    NTE_SIGNATURE_FILE_BAD: err := 'NTE_SIGNATURE_FILE_BAD';
    else err := 'Unknown error';
    end;
    MessageDlg('  : ' + err, mtError, [mbOK], 0);
    exit;
    end;
if KEKCheckBox.Checked then
 repeat
   if not CryptGetUserKey(hProv, AT_KEYEXCHANGE, @key) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      NTE_NO_KEY: err := 'NTE_NO_KEY';
      else err := 'Unknown error';
      end;
      MessageDlg('    : ' + err,
                         mtError, [mbOK], 0);
      break;
      end;
   if not CryptExportKey(key, 0, PUBLICKEYBLOB, 0, nil, @bufLen) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      ERROR_MORE_DATA: err := 'ERROR_MORE_DATA';
      NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_KEY_STATE: err := 'NTE_BAD_KEY_STATE';
      NTE_BAD_PUBLIC_KEY: err := 'NTE_BAD_PUBLIC_KEY';
      NTE_BAD_TYPE: err := 'NTE_BAD_TYPE';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      NTE_NO_KEY: err := 'NTE_NO_KEY';
      else err := 'Unknown error';
      end;
      MessageDlg('   BLOB''   : ' + err,
                         mtError, [mbOK], 0);
      break;
      end;
   GetMem(pbuf, bufLen);
   if not CryptExportKey(key, 0, PUBLICKEYBLOB, 0, pbuf, @bufLen) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      ERROR_MORE_DATA: err := 'ERROR_MORE_DATA';
      NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_KEY_STATE: err := 'NTE_BAD_KEY_STATE';
      NTE_BAD_PUBLIC_KEY: err := 'NTE_BAD_PUBLIC_KEY';
      NTE_BAD_TYPE: err := 'NTE_BAD_TYPE';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      NTE_NO_KEY: err := 'NTE_NO_KEY';
      else err := 'Unknown error';
      end;
      MessageDlg('    : ' + err,
                         mtError, [mbOK], 0);
      break;
      end;
   if not CryptDestroyKey(key) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      else err := 'Unknown error';
      end;
      MessageDlg('     : ' + err,
                         mtError, [mbOK], 0);
      end;
   SaveDialog1.Title := '      ';
   if SaveDialog1.Execute then
      begin
      
      end;
 until true; {KeyExchange}
end;

end.
