unit KImport;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, wcrypt2;

type
  TImportForm = class(TForm)
    Label1: TLabel;
    ContainerEdit: TEdit;
    PasswLabel: TLabel;
    PasswEdit: TEdit;
    OKBtn: TBitBtn;
    CloseBtn: TBitBtn;
    OpenDlg: TOpenDialog;
    procedure CloseBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ImportForm: TImportForm;

implementation

{$R *.DFM}

procedure TImportForm.CloseBtnClick(Sender: TObject);
begin
Close;
end;

procedure TImportForm.OKBtnClick(Sender: TObject);
var cont: PChar;
    err: string;
    hProv: HCRYPTPROV;
    key, expKey: HCRYPTKEY;
    buf: PBYTE;
    buflen: DWORD;
    f: file;
    hash: HCRYPTHASH;
begin
if length(ContainerEdit.Text) = 0
then
    begin
    cont := nil;
    err := ' ';
    end
else
    begin
    err := ContainerEdit.Text;
    cont := StrAlloc(length(err) + 1);
    StrPCopy(cont, err);
    end;
if not CryptAcquireContext(@hProv, cont, nil, PROV_RSA_FULL, 0)
then
    begin
    case int64(GetLastError) of
    ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
    ERROR_NOT_ENOUGH_MEMORY: err := 'ERROR_NOT_ENOUGH_MEMORY';
    NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
    NTE_BAD_KEYSET: err := 'NTE_BAD_KEYSET';
    NTE_BAD_KEYSET_PARAM: err := 'NTE_BAD_KEYSET_PARAM';
    NTE_BAD_PROV_TYPE: err := 'NTE_BAD_PROV_TYPE';
    NTE_BAD_SIGNATURE: err := 'NTE_BAD_SIGNATURE';
    NTE_EXISTS: err := 'NTE_EXISTS';
    NTE_KEYSET_ENTRY_BAD: err := 'NTE_KEYSET_ENTRY_BAD';
    NTE_KEYSET_NOT_DEF: err := 'NTE_KEYSET_NOT_DEF';
    NTE_NO_MEMORY: err := 'NTE_NO_MEMORY';
    NTE_PROV_DLL_NOT_FOUND: err := 'NTE_PROV_DLL_NOT_FOUND';
    NTE_PROV_TYPE_ENTRY_BAD: err := 'NTE_PROV_TYPE_ENTRY_BAD';
    NTE_PROV_TYPE_NO_MATCH: err := 'NTE_PROV_TYPE_NO_MATCH';
    NTE_PROV_TYPE_NOT_DEF: err := 'NTE_PROV_TYPE_NOT_DEF';
    NTE_PROVIDER_DLL_FAIL: err := 'NTE_PROVIDER_DLL_FAIL';
    NTE_SIGNATURE_FILE_BAD: err := 'NTE_SIGNATURE_FILE_BAD';
    else err := 'Unknown error';
    end;
    MessageDlg('  : ' + err, mtError, [mbOK], 0);
    exit;
    end;
if not CryptCreateHash(hProv, CALG_SHA, 0, 0, @hash) then
   begin
   case int64(GetLastError) of
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   ERROR_NOT_ENOUGH_MEMORY: err := 'ERROR_NOT_ENOUGH_MEMORY';
   NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
   NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
   NTE_BAD_KEY: err := 'NTE_BAD_KEY';
   NTE_NO_MEMORY: err := 'NTE_NO_MEMORY';
   else err := 'Unknown error';
   end;
   MessageDlg('  -: ' + err, mtError, [mbOK], 0);
   exit;
   end;
if not CryptHashData(hash, @(PasswEdit.Text[1]), length(PasswEdit.Text), 0) then
   begin
   case int64(GetLastError) of
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
   NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
   NTE_BAD_HASH: err := 'NTE_BAD_HASH';
   NTE_BAD_HASH_STATE: err := 'NTE_BAD_HASH_STATE';
   NTE_BAD_KEY: err := 'NTE_BAD_KEY';
   NTE_BAD_LEN: err := 'NTE_BAD_LEN';
   NTE_BAD_UID: err := 'NTE_BAD_UID';
   NTE_FAIL: err := 'NTE_FAIL';
   NTE_NO_MEMORY: err := 'NTE_NO_MEMORY';
   else err := 'Unknown error';
   end;
   MessageDlg('  : ' + err, mtError, [mbOK], 0);
   exit;
   end;
if not CryptDeriveKey(hProv, CALG_RC4, hash, 0, @expKey) then
   begin
   case int64(GetLastError) of
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
   NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
   NTE_BAD_HASH: err := 'NTE_BAD_HASH';
   NTE_BAD_HASH_STATE: err := 'NTE_BAD_HASH_STATE';
   NTE_BAD_UID: err := 'NTE_BAD_UID';
   NTE_FAIL: err := 'NTE_FAIL';
   else err := 'Unknown error';
   end;
   MessageDlg('Error of CryptHashData: '+err,
                        mtError, [mbOK], 0);
   exit;
   end;
if not CryptDestroyHash(hash) then
   begin
   case int64(GetLastError) of
   ERROR_BUSY: err := 'ERROR_BUSY';
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
   NTE_BAD_HASH: err := 'NTE_BAD_HASH';
   NTE_BAD_UID: err := 'NTE_BAD_UID';
   else err := 'Unknown error';
   end;
   MessageDlg('   : ' + err, mtError, [mbOK], 0);
   end;
OpenDlg.Title := '   ';
if OpenDlg.Execute then
   begin
   AssignFile(f, OpenDlg.FileName);
   reset(f, 1);
   buflen := FileSize(f);
   GetMem(buf, buflen);
   BlockRead(f, buf^, buflen);
   CloseFile(f);
   if not CryptImportKey(hProv, buf, buflen, expKey, CRYPT_EXPORTABLE, @key) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      NTE_BAD_ALGID: err := 'NTE_BAD_ALGID';
      NTE_BAD_DATA: err := 'NTE_BAD_DATA';
      NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
      NTE_BAD_TYPE: err := 'NTE_BAD_TYPE';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      NTE_BAD_VER: err := 'NTE_BAD_VER';
      else err := 'Unknown error';
      end;
      MessageDlg('  : ' + err,
                         mtError, [mbOK], 0);
      end;
   FreeMem(buf, buflen);
   if not CryptDestroyKey(key) then
      begin
      case int64(GetLastError) of
      ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
      ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
      NTE_BAD_KEY: err := 'NTE_BAD_KEY';
      NTE_BAD_UID: err := 'NTE_BAD_UID';
      else err := 'Unknown error';
      end;
      MessageDlg('   : ' + err,
                         mtError, [mbOK], 0);
      end;
   end;
if not CryptDestroyKey(expKey) then
   begin
   case int64(GetLastError) of
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   NTE_BAD_KEY: err := 'NTE_BAD_KEY';
   NTE_BAD_UID: err := 'NTE_BAD_UID';
   else err := 'Unknown error';
   end;
   MessageDlg('  : ' + err,
                         mtError, [mbOK], 0);
   end;
if not CryptReleaseContext(hProv, 0) then
   begin
   case int64(GetLastError) of
   ERROR_BUSY: err := 'ERROR_BUSY';
   ERROR_INVALID_HANDLE: err := 'ERROR_INVALID_HANDLE';
   ERROR_INVALID_PARAMETER: err := 'ERROR_INVALID_PARAMETER';
   NTE_BAD_FLAGS: err := 'NTE_BAD_FLAGS';
   NTE_BAD_UID: err := 'NTE_BAD_UID';
   else err := 'Unknown error';
   end;
   MessageDlg('   : ' + err,
       mtError, [mbOK], 0);
   end;
end;

end.
